Mesh Scripting/id: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
Line 4: Line 4:
=== Introduction ===
=== Introduction ===
First of all you have to import the Mesh module:
First of all you have to import the Mesh module:
{{Code|code=
<syntaxhighlight>
import Mesh
import Mesh
}}
</syntaxhighlight>
After that you have access to the Mesh module and the Mesh class which facilitate the functions
After that you have access to the Mesh module and the Mesh class which facilitate the functions
of the FreeCAD C++ Mesh-Kernel.
of the FreeCAD C++ Mesh-Kernel.
Line 13: Line 13:
To create an empty mesh object just use the standard constructor:
To create an empty mesh object just use the standard constructor:


{{Code|code=
<syntaxhighlight>
mesh = Mesh.Mesh()
mesh = Mesh.Mesh()
}}
</syntaxhighlight>


You can also create an object from a file
You can also create an object from a file


{{Code|code=
<syntaxhighlight>
mesh = Mesh.Mesh('D:/temp/Something.stl')
mesh = Mesh.Mesh('D:/temp/Something.stl')
}}
</syntaxhighlight>


(A list of compatible filetypes can be found under 'Meshes' [[Feature_list#IO|here]].)
(A list of compatible filetypes can be found under 'Meshes' [[Feature_list#IO|here]].)
Line 27: Line 27:
Or create it out of a set of triangles described by their corner points:
Or create it out of a set of triangles described by their corner points:


{{Code|code=
<syntaxhighlight>
planarMesh = [
planarMesh = [
# triangle 1
# triangle 1
Line 36: Line 36:
planarMeshObject = Mesh.Mesh(planarMesh)
planarMeshObject = Mesh.Mesh(planarMesh)
Mesh.show(planarMeshObject)
Mesh.show(planarMeshObject)
}}
</syntaxhighlight>


The Mesh-Kernel takes care about creating a topological correct data structure by sorting
The Mesh-Kernel takes care about creating a topological correct data structure by sorting
Line 46: Line 46:
To create regular geometries you can use the Python script BuildRegularGeoms.py.
To create regular geometries you can use the Python script BuildRegularGeoms.py.


{{Code|code=
<syntaxhighlight>
import BuildRegularGeoms
import BuildRegularGeoms
}}
</syntaxhighlight>


This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube.
This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube.
To create a toroid, for instance, can be done as follows:
To create a toroid, for instance, can be done as follows:


{{Code|code=
<syntaxhighlight>
t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
m = Mesh.Mesh(t)
m = Mesh.Mesh(t)
}}
</syntaxhighlight>


The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is.
The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is.
The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.
The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.


{{Code|code=
<syntaxhighlight>
m1, m2 # are the input mesh objects
m1, m2 # are the input mesh objects
m3 = Mesh.Mesh(m1) # create a copy of m1
m3 = Mesh.Mesh(m1) # create a copy of m1
Line 71: Line 71:
m6 = Mesh.Mesh(m2)
m6 = Mesh.Mesh(m2)
m6.difference(m1) # the difference of m2 and m1, usually the result is different to m5
m6.difference(m1) # the difference of m2 and m1, usually the result is different to m5
}}
</syntaxhighlight>


Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.
Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.


{{Code|code=
<syntaxhighlight>
import Mesh, BuildRegularGeoms
import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
Line 84: Line 84:
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.recompute()
d.recompute()
}}
</syntaxhighlight>


=== Examining and Testing ===
=== Examining and Testing ===
Line 93: Line 93:
You can even write the mesh to a python module:
You can even write the mesh to a python module:


{{Code|code=
<syntaxhighlight>
m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
import SavedMesh
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)
m2 = Mesh.Mesh(SavedMesh.faces)
}}
</syntaxhighlight>


=== Gui related stuff ===
=== Gui related stuff ===

Revision as of 09:51, 14 February 2019

FreeCAD Scripting Basics
Topological data scripting

Introduction

First of all you have to import the Mesh module:

import Mesh

After that you have access to the Mesh module and the Mesh class which facilitate the functions of the FreeCAD C++ Mesh-Kernel.

Creation and Loading

To create an empty mesh object just use the standard constructor:

mesh = Mesh.Mesh()

You can also create an object from a file

mesh = Mesh.Mesh('D:/temp/Something.stl')

(A list of compatible filetypes can be found under 'Meshes' here.)

Or create it out of a set of triangles described by their corner points:

planarMesh = [
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
#triangle 2
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
]
planarMeshObject = Mesh.Mesh(planarMesh)
Mesh.show(planarMeshObject)

The Mesh-Kernel takes care about creating a topological correct data structure by sorting coincident points and edges together.

Later on you will see how you can test and examine mesh data.

Modeling

To create regular geometries you can use the Python script BuildRegularGeoms.py.

import BuildRegularGeoms

This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube. To create a toroid, for instance, can be done as follows:

t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
m = Mesh.Mesh(t)

The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is. The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.

m1, m2              # are the input mesh objects
m3 = Mesh.Mesh(m1)  # create a copy of m1
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2)    # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2)   # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5

Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.

import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
diff = sphere
diff = diff.difference(cylinder)
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.recompute()

Examining and Testing

Write your own Algorithms

Exporting

You can even write the mesh to a python module:

m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)

Gui related stuff

Odds and Ends

An extensive (though hard to use) source of Mesh related scripting are the unit test scripts of the Mesh-Module. In this unit tests literally all methods are called and all properties/attributes are tweaked. So if you are bold enough, take a look at the Unit Test module.

See also Mesh API

FreeCAD Scripting Basics
Topological data scripting